% Carte de champ avec interpolation et position des tiges
% Grard Tayeb, 12/2005
%========================================================
% Ce script contient plein d'exemples. 
% Il est conseill de l'excuter par petits morceaux, pour voir ce qui peut etre utile  telle ou telle situation.
% Les amliorations sont les bienvenues... (voir "A faire" en bas du script).
%========================================================
clear all;
% colormap('jet')

% Titre du graphe
% Pour ne pas transformer les _ en caractres en indice, utiliser la commande 
%   title(titre,'Interpreter','none')
titre='Luo19x50_nntig3nb600_nntot100';
fichiertiges = 'Luo19x50.tiges';

tiges = dlmread(fichiertiges,' ',1,0);
% fichierchamp = ['cartechamp.',titre,'_carte.dat'];
fichierchamp = ['cartechamp.',titre,'.dat'];
fichiergaine = ['prof_norm.',titre];
champ = dlmread(fichierchamp,' ',1,0);
gaine = dlmread(fichiergaine,' ',1,0);

% Champ
x = unique(champ(:,1)); xmin = min(x); xmax = max(x); nx=length(x); dx = (xmax-xmin)/(nx-1);
y = unique(champ(:,2)); ymin = min(y); ymax = max(y); ny=length(y); dy = (ymax-ymin)/(ny-1);

% Position des tiges :
xc = tiges(:,2);
yc = tiges(:,3);
ray = tiges(:,9); dia = 2*ray;
nt=length(xc);

% Contour de la gaine :
xd = gaine(:,1); yd = gaine(:,2);

%----------------------------------------------------
% Carte interpole avec tiges:

modu=champ(:,3); % attention: 3 pour le module, 4 pour la phase
z=reshape(modu,ny,[]);
% Au lieu d'utiliser pcolor(x,y,z), on interpole sur un pas deux fois plus fin => carte bien plus finement dessine
[xi,yi] = meshgrid(xmin:dx/2:xmax,ymin:dy/2:ymax);
zi = interp2(x,y,z,xi,yi);

% Dgrads
% pcolor(xi,yi,zi) % dgrads
% shading interp % Remplace la valeur par dfaut 'faceted', supprime la mesh et interpole
% caxis([0 1]); colorbar;

% Contour
zmin = 0; zmax = 1; deltaz = 0.1; % utiliss pour lignes de niveau et colorbar
nbcouleurs = (zmax-zmin)/deltaz;
colormap(jet(nbcouleurs)); % cre une palette de couleurs restreintes
v = [zmin:deltaz:zmax]  
[C,h] = contourf(xi,yi,zi,v); % contour avec lignes de niveau
clabel(C,h); % pour afficher les valeurs des lignes de niveau
caxis([zmin zmax]); colorbar;

axis square; 
title(titre,'Interpreter','none');

% Ajout des tiges
for it=1:nt
    rectangle('Position',[xc(it)-ray(it),yc(it)-ray(it),dia(it),dia(it)],'Curvature',[1,1],'EdgeColor','k','LineWidth',0.5)
end

% Ajout de la gaine
hold on;
plot(xd,yd,'k','LineWidth',0.5);

%----------------------------------------------------
% Colormap allant d'une couleur  une autre:
figure
colormap(deuxcouleursGT(nbcouleurs))
[C,h] = contourf(xi,yi,zi,v); % contour avec lignes de niveau
caxis([zmin zmax]); colorbar;

%----------------------------------------------------
% Sans lignes de niveau:
figure
colormap(deuxcouleursGT(40))
pcolor(xi,yi,zi) % dgrads
shading interp % Remplace la valeur par dfaut 'faceted', supprime la mesh et interpole
caxis([0 1]); colorbar;

% Ajout des tiges
for it=1:nt
    rectangle('Position',[xc(it)-ray(it),yc(it)-ray(it),dia(it),dia(it)],'Curvature',[1,1],'EdgeColor','k','LineWidth',0.5)
end
% Ajout de la gaine
hold on;
plot(xd,yd,'k','LineWidth',0.5);

%----------------------------------------------------
% Exporter en fichier graphique:
% On peut le faire depuis la figure avec File / Export
% ou bien en ligne de commande:
print -depsc myfigure
% Mais dans tous les cas, a me donne des rsultats MINABLES
% => il vaut mieux faire une copie d'cran

%----------------------------------------------------
% A faire:
% Ajouter des tickmarks sur les axes (sur les 4 cots).
% Mettre d'autres couleurs pour les valeurs qui dpassent les min et max (noir et magenta sur mes graphes Origin).
% Exporter en fichier graphique